Index: LMDZ6/trunk/libf/misc/readTracFiles_mod.f90
===================================================================
--- LMDZ6/trunk/libf/misc/readTracFiles_mod.f90	(revision 4062)
+++ LMDZ6/trunk/libf/misc/readTracFiles_mod.f90	(revision 4063)
@@ -1,7 +1,7 @@
 MODULE readTracFiles_mod
 
-  USE strings_mod, ONLY:   msg, testFile,  strFind, strStack, strReduce,  strHead, strCount,   find, maxlen, fmsg, &
-            removeComment, cat, checkList, strIdx,  strParse, strReplace, strTail, reduceExpr, test, get_in, dispTable
-  USE trac_types_mod, ONLY : trac_type, isot_type, keys_type
+  USE strings_mod,    ONLY: msg, testFile,  strFind, strStack, strReduce,  strHead, strCount,   find, maxlen, fmsg, &
+             removeComment, cat, checkList, strIdx,  strParse, strReplace, strTail, reduceExpr, test, get_in, dispTable
+  USE trac_types_mod, ONLY: trac_type, isot_type, keys_type
 
   IMPLICIT NONE
@@ -9,6 +9,6 @@
   PRIVATE
 
-  PUBLIC :: initIsotopes, maxlen, trac_type, isot_type
-  PUBLIC :: readTracersFiles, aliasTracer, tracersSubset, indexUpdate!--- TOOLS ASSOCIATED TO TRACERS  DESCRIPTORS
+  PUBLIC :: initIsotopes, maxlen, trac_type, isot_type, keys_type
+  PUBLIC :: readTracersFiles, indexUpdate, setGeneration             !--- TOOLS ASSOCIATED TO TRACERS  DESCRIPTORS
   PUBLIC :: readIsotopesFile                                         !--- TOOLS ASSOCIATED TO ISOTOPES DESCRIPTORS
   PUBLIC :: getKey_init, getKey, setDirectKeys                       !--- GET/SET KEYS FROM/TO tracers & isotopes
@@ -45,7 +45,7 @@
   CHARACTER(LEN=maxlen), SAVE      :: phases_names(nphases) &        !--- Known phases names
                                 = ['gaseous', 'liquid ', 'solid  ']
-  CHARACTER(LEN=1),   SAVE      :: phases_sep  =  '_'                !--- Phase separator
-  LOGICAL,            SAVE      :: tracs_merge = .TRUE.              !--- Merge/stack tracers lists
-  LOGICAL,            SAVE      :: lSortByGen  = .TRUE.              !--- Sort by growing generation
+  CHARACTER(LEN=1), SAVE :: phases_sep  =  '_'                       !--- Phase separator
+  LOGICAL,          SAVE :: tracs_merge = .TRUE.                     !--- Merge/stack tracers lists
+  LOGICAL,          SAVE :: lSortByGen  = .TRUE.                     !--- Sort by growing generation
 
   !=== LOCAL COPIES OF THE TRACERS AND ISOTOPES DESCRIPTORS, USED BY getKey (INITIALIZED IN getKey_init)
@@ -76,7 +76,7 @@
 !     * The "keys" component (of type keys_type) is in principle enough to store everything we could need.
 !     But some variables are stored as direct-access keys to make the code more readable and because they are used often.
-!     * Most of the direct-access keys are set in this module, but some are not (lnam, iadv and itr for example).
+!     * Most of the direct-access keys are set in this module, but some are not (longName, iadv, isAdvected for now).
 !     * Some of the direct-access keys must be updated (using the routine "setDirectKeys") is a subset of "tracers(:)"
-!     is extracted: the indexes are no longer valid for a subset (examples: tracers(:)%iqParent or tracers(:)%ichld).
+!     is extracted: the indexes are no longer valid for a subset (examples: iqParent, iqDescen).
 !     * If you need to convert a %key/%val pair into a direct-access key, add the corresponding line in "setDirectKeys".
 !==============================================================================================================================
@@ -87,6 +87,6 @@
   TYPE(trac_type), ALLOCATABLE, INTENT(OUT) :: tracs(:)
   CHARACTER(LEN=maxlen),  ALLOCATABLE ::  s(:), sections(:), trac_files(:)
-  CHARACTER(LEN=maxlen) :: str, fname, mesg
-  INTEGER               :: is, nsec, ierr, it, ntrac, ns, ip
+  CHARACTER(LEN=maxlen) :: str, fname, mesg, oldH2O, newH2O
+  INTEGER               :: is, nsec, ierr, it, ntrac, ns, ip, ix
   LOGICAL, ALLOCATABLE  :: ll(:), lGen3(:)
 !------------------------------------------------------------------------------------------------------------------------------
@@ -111,4 +111,7 @@
   END IF
 
+  !--- CHECK WHETHER type_trac AND FILE TYPE ARE COMPATIBLE
+  IF(test(fmsg('No multiple sections for the old format "traceur.def"', ll = SIZE(sections)>1 .AND. fType==1), lerr)) RETURN
+
   !--- TELLS WHAT WAS IS ABOUT TO BE USED
   IF (fmsg('No adequate tracers description file(s) found ; default values will be used',          modname, fType==0)) RETURN
@@ -118,61 +121,67 @@
 
   !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-  IF(fType==1) THEN                                                  !=== OLD FORMAT "traceur.def"
-  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-    !--- OPEN THE "traceur.def" FILE
-    OPEN(90, FILE="traceur.def", FORM='formatted', STATUS='old', IOSTAT=ierr)
-
-    !--- GET THE TRACERS NUMBER
-    READ(90,'(i3)',IOSTAT=ierr)ntrac                                 !--- Number of lines/tracers
-    IF(test(fmsg('Invalid format for "'//TRIM(fname)//'"', modname, ierr /= 0), lerr)) RETURN
-
-    !--- READ THE REMAINING LINES: <hadv> <vadv> <tracer> [<transporting fluid>]
-    ALLOCATE(tracs(ntrac))
-    DO it=1,ntrac                                                    !=== READ RAW DATA: loop on the line/tracer number
-      READ(90,'(a)',IOSTAT=ierr) str
-      IF(test(fmsg('Invalid format for "' //TRIM(fname)//'"', modname, ierr>0), lerr)) RETURN
-      IF(test(fmsg('Not enough lines in "'//TRIM(fname)//'"', modname, ierr<0), lerr)) RETURN
-      ll = strParse(str, ' ', s, n=ns)
-      tracs(it)%keys%key = ['hadv', 'vadv']
-      tracs(it)%keys%val = s(1:2)
-      CALL msg('This file is for air tracers only',           modname, ns == 3 .AND. it == 1)
-      CALL msg('This files specifies the transporting fluid', modname, ns == 4 .AND. it == 1)
-      tracs(it)%name = TRIM(s(3))                                    !--- Name of the tracer
-      tracs(it)%phase = known_phases(1:1)                            !--- Phase (default: "g" for gazeous)
+  SELECT CASE(fType)                         !--- Set %name, %genOName, %parent, %type, %phase, %component, %iGeneration, %keys
+  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+    CASE(1)                                                               !=== OLD FORMAT "traceur.def"
+    !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+      !--- OPEN THE "traceur.def" FILE
+      OPEN(90, FILE="traceur.def", FORM='formatted', STATUS='old', IOSTAT=ierr)
+
+      !--- GET THE TRACERS NUMBER
+      READ(90,'(i3)',IOSTAT=ierr)ntrac                               !--- Number of lines/tracers
+      IF(test(fmsg('Invalid format for "'//TRIM(fname)//'"', modname, ierr /= 0), lerr)) RETURN
+
+      !--- READ THE REMAINING LINES: <hadv> <vadv> <tracer> [<transporting fluid>]
+      ALLOCATE(tracs(ntrac))
+      DO it=1,ntrac                                                  !=== READ RAW DATA: loop on the line/tracer number
+        READ(90,'(a)',IOSTAT=ierr) str
+        IF(test(fmsg('Invalid format for "' //TRIM(fname)//'"', modname, ierr>0), lerr)) RETURN
+        IF(test(fmsg('Not enough lines in "'//TRIM(fname)//'"', modname, ierr<0), lerr)) RETURN
+        ll = strParse(str, ' ', s, n=ns)
+        CALL msg('This file is for air tracers only',           modname, ns == 3 .AND. it == 1)
+        CALL msg('This files specifies the transporting fluid', modname, ns == 4 .AND. it == 1)
+        tracs(it)%name = TRIM(s(3))                                  !--- Set %name:   name of the tracer
+        tracs(it)%parent = tran0                                     !--- Set %parent: transporting fluid
+        IF(ns == 4) tracs(it)%parent = s(4)                          !---     default: 'air' or defined in the file
+        tracs(it)%phase = known_phases(1:1)                          !--- Set %phase:  tracer phase (default: "g"azeous)
+        tracs(it)%component = TRIM(type_trac)                        !--- Set %component: model component name
+        tracs(it)%keys%key = ['hadv', 'vadv']                        !--- Set %keys%key
+        tracs(it)%keys%val = s(1:2)                                  !--- Set %keys%val
+      END DO
+      CLOSE(90)
       DO ip = 1, nphases                                             !--- Deal with old water names
-        IF(s(3) /= 'H2O'//old_phases(ip:ip)) CYCLE
-        tracs(it)%phase = known_phases(ip:ip); tracs(it)%name = 'H2O'//phases_sep//TRIM(tracs(it)%phase)
+        oldH2O = 'H2O'//old_phases(ip:ip)
+        newH2O = 'H2O'//phases_sep//known_phases(ip:ip)
+        ix = strIdx(tracs(:)%name, oldH2O)
+        IF(ix == 0) CYCLE
+        tracs(ix)%name  = newH2O                                     !--- Set %name:   name of the tracer
+        WHERE(tracs(:)%parent == oldH2O) tracs(:)%parent = newH2O    !--- Set %parent: transporting fluid
+        tracs(ix)%phase = known_phases(ip:ip)                        !--- Set %phase:  tracer phase
       END DO
-      tracs(it)%parent = tran0                                       !--- Default transporting fluid: Air
-      IF(ns == 4) tracs(it)%parent = s(4)                            !--- Transporting fluid name
-    END DO
-    CLOSE(90)
-
-    lGen3 = tracs%iGeneration==3
-    CALL setGeneration(tracs)                                        !--- Determine tracs(:)%iGeneration values
-    IF(test(checkTracers(tracs,      fname,fname),lerr)) RETURN      !--- Detect orphans and check phases
-    IF(test(checkUnique (tracs,lGen3,fname,fname),lerr)) RETURN      !--- Detect repeated tracers
-    CALL sortTracers  (tracs)                                        !--- Sort the tracers
-    CALL setDirectKeys(tracs)                                        !--- Set the directly accessible keys
-    tracs(:)%keys%name = tracs(:)%name                               !--- Copy tracers names in keys components
-    RETURN
-  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+      CALL setGeneration(tracs)                                      !--- Set %iGeneration and %gen0Name
+      WHERE(tracs%iGeneration == 3) tracs%type = 'tag'               !--- Set %type:        'tracer' or 'tag'
+      IF(test(checkTracers(tracs, fname, fname), lerr)) RETURN       !--- Detect orphans and check phases
+      IF(test(checkUnique (tracs, fname, fname), lerr)) RETURN       !--- Detect repeated tracers
+      CALL sortTracers  (tracs)                                      !--- Sort the tracers
+      tracs(:)%keys%name = tracs(:)%name                             !--- Copy tracers names in keys components
+    !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+    CASE(2); IF(test(feedDBase(["tracer.def"],[type_trac]), lerr)) RETURN  !=== SINGLE FILE, COMA-SEPARATED SECTIONS LIST
+    !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+    CASE(3); IF(test(feedDBase(  trac_files  , sections  ), lerr)) RETURN  !=== MULTIPLE FILES, ONE SECTION EACH FILE
+  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+  END SELECT
+  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+  IF(ANY([2,3] == fType) .AND. nsec > 1) THEN
+    IF(tracs_merge) THEN
+      CALL msg('The multiple required sections will be MERGED.',    modname)
+      IF(test(mergeTracers(dBase, tracs), lerr)) RETURN
+    ELSE
+      CALL msg('The multiple required sections will be CUMULATED.', modname)
+      IF(test(cumulTracers(dBase, tracs), lerr)) RETURN
+    END IF
+    WHERE(tracs%gen0Name(1:3) == 'H2O') tracs%isH2Ofamily=.TRUE.     !--- Set %isH2Ofamily: belongs to H2O family
+    CALL setDirectKeys(tracs)                                        !--- Set %iqParent, %iqDescen, %nqDescen, %nqChilds
   END IF
-  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-
-  !=== USING NEW FORMAT TRACERS DESCRIPTION FILES WITH POSSIBLY SEVERAL SECTIONS
-  CALL msg('The multiple required sections will be MERGED.',    modname, nsec > 1 .AND.      tracs_merge)
-  CALL msg('The multiple required sections will be CUMULATED.', modname, nsec > 1 .AND. .NOT.tracs_merge)
-
-  !=== FEED THE DATABASE WITH THE RAW CONTENT OF THE FILE
-  SELECT CASE(fType)
-    CASE(2); lerr = feedDBase(["tracer.def"],[type_trac])            !--- Single file, coma-separated sections list
-    CASE(3); lerr = feedDBase(trac_files,     sections  )            !--- Multiple files, one section name each file
-  END SELECT
-  IF(lerr) RETURN
-  IF(     tracs_merge) lerr = mergeTracers(dBase, tracs)             !--- MERGE    THE COMPONENTS OF THE DATABASE
-  IF(.NOT.tracs_merge) lerr = cumulTracers(dBase, tracs)             !--- CUMULATE THE COMPONENTS OF THE DATABASE
-  IF(lerr) RETURN
-  CALL setDirectKeys(tracs)                                          !--- Set the directly accessible keys
 
 END FUNCTION readTracersFiles
@@ -201,5 +210,5 @@
   ll = strCount(snames, ',', ndb)                                    !--- Number of sections for each file
   ALLOCATE(ixf(SUM(ndb)))
-  DO i=1, SIZE(fnames)
+  DO i=1, SIZE(fnames)                                               !--- Set %name, %keys
     IF(test(readSections(fnames(i), snames(i), 'default'), lerr)) RETURN
     ixf(1+SUM(ndb(1:i-1)):SUM(ndb(1:i))) = i                         !--- File index for each section of the expanded list
@@ -208,11 +217,10 @@
   DO idb=1,SIZE(dBase)                                               !--- LOOP ON THE LOADED SECTIONS
   !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-    fnm = fnames(ixf(idb)); snm = dBase(idb)%name
-    IF(test(expandSection(dBase(idb)%trac,   snm, fnm),lerr)) RETURN !--- EXPAND NAMES AND PARENTS LISTS
-    CALL setGeneration   (dBase(idb)%trac)                           !--- DETERMINE GENERATION NUMBER
-    IF(test(checkTracers (dBase(idb)%trac,   snm, fnm),lerr)) RETURN !--- CHECK ORPHANS AND PHASES
-    lTg = dBase(idb)%trac(:)%type == 'tag'                           !--- Flag for tagging tracers
-    IF(test(checkUnique  (dBase(idb)%trac,lTg,snm,fnm),lerr)) RETURN !--- CHECK TRACERS UNIQUENESS
-    CALL expandPhases    (dBase(idb)%trac)                           !--- EXPAND THE PHASES
+    fnm = fnames(ixf(idb)); snm = dBase(idb)%name                    !--- FILE AND SECTION NAMES
+    IF(test(expandSection(dBase(idb)%trac, snm, fnm), lerr)) RETURN  !--- EXPAND NAMES ;  set %parent, %type, %component
+    CALL setGeneration   (dBase(idb)%trac)                           !---                 set %iGeneration,   %genOName
+    IF(test(checkTracers (dBase(idb)%trac, snm, fnm), lerr)) RETURN  !--- CHECK ORPHANS AND PHASES
+    IF(test(checkUnique  (dBase(idb)%trac, snm, fnm), lerr)) RETURN  !--- CHECK TRACERS UNIQUENESS
+    CALL expandPhases    (dBase(idb)%trac)                           !--- EXPAND PHASES ; set %phase
     CALL sortTracers     (dBase(idb)%trac)                           !--- SORT TRACERS
   !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
@@ -283,8 +291,8 @@
       ll = strParse(str,' ', keys = s, vals = v, n = n)              !--- Parse <key>=<val> pairs
       tt = dBase(ndb)%trac(:)
-      tmp%name = s(1); tmp%component=secn; tmp%keys = keys_type(s(1), s(2:n), v(2:n))
+      tmp%name = s(1); tmp%keys = keys_type(s(1), s(2:n), v(2:n))    !--- Set %name and %keys
       dBase(ndb)%trac = [tt(:), tmp]
       DEALLOCATE(tt)
-!      dBase(ndb)%trac = [dBase(ndb)%trac(:), tra(name=s(1), comp=secn, keys=keys_type(s(1), s(2:n), v(2:n)))]
+!      dBase(ndb)%trac = [dBase(ndb)%trac(:), tra(name=s(1), keys=keys_type(s(1), s(2:n), v(2:n)))]
     END IF
   END DO
@@ -421,24 +429,21 @@
 !------------------------------------------------------------------------------------------------------------------------------
 ! Purpose: Determine, for each tracer of "tr(:)":
-!   * the generation number 
-!   * the first generation ancestor name
-!------------------------------------------------------------------------------------------------------------------------------
-! Arguments:
-  TYPE(trac_type), INTENT(INOUT) :: tr(:)                            !--- Tracer derived type vector
-!------------------------------------------------------------------------------------------------------------------------------
-! Local variables:
-  INTEGER :: iq, nq, ig
+!   * %iGeneration: the generation number 
+!   * %gen0Name:    the generation 0 ancestor name
+!------------------------------------------------------------------------------------------------------------------------------
+  TYPE(trac_type),     INTENT(INOUT) :: tr(:)                        !--- Tracer derived type vector
+  INTEGER                            :: iq, nq, ig
   LOGICAL,               ALLOCATABLE :: lg(:)
   CHARACTER(LEN=maxlen), ALLOCATABLE :: prn(:)
 !------------------------------------------------------------------------------------------------------------------------------
-  tr(:)%iGeneration = 0                                              !--- error if 0
+  tr(:)%iGeneration = -1                                             !--- error if -1
   nq = SIZE(tr, DIM=1)                                               !--- Number of tracers lines
   lg = tr(:)%parent == tran0                                         !--- First generation tracers flag
-  WHERE(lg) tr(:)%iGeneration = 1                                    !--- First generation tracers
+  WHERE(lg) tr(:)%iGeneration = 0                                    !--- First generation tracers
 
   !=== Determine generation for each tracer
-  ig=0; prn = [tran0]
+  ig=-1; prn = [tran0]
   DO                                                                 !--- Update current generation flag
-    IF(ig/=0) prn = PACK( tr(:)%name, MASK=tr(:)%iGeneration == ig)
+    IF(ig/=-1) prn = PACK( tr(:)%name, MASK=tr(:)%iGeneration == ig)
     lg(:) = [(ANY(prn(:) == tr(iq)%parent), iq=1, nq)]               !--- Current generation tracers flag
     IF( ALL( .NOT. lg ) ) EXIT                                       !--- Empty current generation
@@ -470,8 +475,8 @@
 
   !=== CHECK FOR ORPHAN TRACERS
-  IF(test(checkList(tr%name, tr%iGeneration==0, mesg, 'tracers', 'orphan'), lerr)) RETURN
+  IF(test(checkList(tr%name, tr%iGeneration==-1, mesg, 'tracers', 'orphan'), lerr)) RETURN
 
   !=== CHECK PHASES
-  DO iq=1,nq; IF(tr(iq)%iGeneration/=1) CYCLE                        !--- Generation 1 only is checked
+  DO iq=1,nq; IF(tr(iq)%iGeneration/=0) CYCLE                        !--- Generation O only is checked
     pha = fgetKey(iq, 'phases', tr(:)%keys, 'g')                     !--- Phases
     np = LEN_TRIM(pha); bp(iq)=' '
@@ -479,15 +484,14 @@
     IF(TRIM(bp(iq)) /= '') bp(iq) = TRIM(tr(iq)%name)//': '//TRIM(bp(iq))
   END DO
-  lerr = checkList(bp, tr%iGeneration==1 .AND. bp/='', mesg, 'tracers phases', 'unknown')
+  lerr = checkList(bp, tr%iGeneration==0 .AND. bp/='', mesg, 'tracers phases', 'unknown')
 END FUNCTION checkTracers
 !==============================================================================================================================
 
 !==============================================================================================================================
-LOGICAL FUNCTION checkUnique(tr, lTag, sname, fname) RESULT(lerr)
+LOGICAL FUNCTION checkUnique(tr, sname, fname) RESULT(lerr)
 !------------------------------------------------------------------------------------------------------------------------------
 ! Purpose: Make sure that tracers are not repeated.
 !------------------------------------------------------------------------------------------------------------------------------
   TYPE(trac_type),            INTENT(IN) :: tr(:)                    !--- Tracer derived type vector
-  LOGICAL,                    INTENT(IN) :: lTag(:)                  !--- Tagging tracer flag
   CHARACTER(LEN=*),           INTENT(IN) :: sname                    !--- Section name
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: fname                    !--- File name
@@ -502,5 +506,5 @@
   nq=SIZE(tr,DIM=1); lerr=.FALSE.                                    !--- Number of lines ; error flag
   tdup(:) = ''
-  DO iq=1,nq; IF(lTag(iq)) CYCLE                                     !--- Tags can be repeated
+  DO iq=1,nq; IF(tr(iq)%type == 'tag') CYCLE                         !--- Tags can be repeated
     tnam = TRIM(tr(iq)%name)
     ll = tr(:)%name==TRIM(tnam)                                      !--- Mask for current tracer name
@@ -585,16 +589,25 @@
 !------------------------------------------------------------------------------------------------------------------------------
 ! Purpose: Sort tracers:
+!  * Put water at first places, in the "known_phases" order.
 !  * lGrowGen == T: in ascending generations numbers.
 !  * lGrowGen == F: tracer + its childs sorted by growing generation, one after the other.
+!   TO BE ADDED IF NECESSARY: HIGHER MOMENTS AT THE END
 !------------------------------------------------------------------------------------------------------------------------------
   TYPE(trac_type), ALLOCATABLE, INTENT(INOUT) :: tr(:)               !--- Tracer derived type vector
-  INTEGER :: ig, ng, iq, jq, n, ix(SIZE(tr)), k
+  INTEGER :: ig, ng, iq, jq, ip, nq, n, ix(SIZE(tr)), k
   INTEGER, ALLOCATABLE :: iy(:), iz(:)
 !------------------------------------------------------------------------------------------------------------------------------
+  nq = SIZE(tr)
+  iy = [(k, k=1, nq)]
+  DO ip = nphases, 1, -1
+    iq = strIdx(tracers(:)%name, 'H2O'//phases_sep//known_phases(ip:ip))
+    IF(iq/=0) iy = [iq, iy(1:iq-1), iy(iq:nq)]
+  END DO
+  tr = tr(iy)                                                        !--- Water displaces at first positions
   iq = 1
   IF(lSortByGen) THEN
     ng = MAXVAL(tr(:)%iGeneration, MASK=.TRUE., DIM=1)               !--- Number of generations
     DO ig = 0, ng                                                    !--- Loop on generations
-      iy = PACK([(k, k=1, SIZE(tr))], MASK=tr(:)%iGeneration==ig)    !--- Generation ig tracers indexes
+      iy = PACK([(k, k=1, nq)], MASK=tr(:)%iGeneration==ig)          !--- Generation ig tracers indexes
       n = SIZE(iy)
       ix(iq:iq+n-1) = iy                                             !--- Stack growing generations idxs
@@ -602,5 +615,5 @@
     END DO
   ELSE
-    DO jq = 1, SIZE(tr,DIM=1)                                        !--- Loop on first generation tracers
+    DO jq = 1, nq                                                    !--- Loop on first generation tracers
       IF(tr(jq)%iGeneration /= 1) CYCLE                              !--- Skip generations >= 1
       ix(iq) = jq                                                    !--- First generation ancestor index first
@@ -727,7 +740,11 @@
 SUBROUTINE setDirectKeys(tr)
   TYPE(trac_type), INTENT(INOUT) :: tr(:)
-  CALL indexUpdate(tr)                                               !--- Update iqParent and iqDescen indexes vectors
+
+  !--- Update %iqParent, %iqDescen, %nqDescen, %nqChilds
+  CALL indexUpdate(tr)
+
+  !--- Extract some direct-access keys
 !  DO iq = 1, SIZE(tr)
-!    tr(iq)%keys%<key> = getKey_prv(it, "<key>", tr%keys,  tran0 )   !--- For additional keys
+!    tr(iq)%keys%<key> = getKey_prv(it, "<key>", tr%keys, <default_value> )
 !  END DO
 END SUBROUTINE setDirectKeys
@@ -829,5 +846,5 @@
 !=== NOTES:                                                                                                                ====
 !===  * Most of the "isot" components have been defined in the calling routine (initIsotopes):                             ====
-!===      prnt,   nzon, zone(:),   niso, keys(:)%name,   nitr, trac(:),   npha, phas,  iTraPha(:,:),  iZonPhi(:,:)         ====
+!===      parent,  nzone, zone(:),  niso, keys(:)%name,  ntiso, trac(:),  nphas, phas,  iTraPha(:,:),  iZonPhi(:,:)        ====
 !===  * Same syntax for isotopes file and "tracer.def": a tracers section contains one line for each of its isotopes       ====
 !===  * Each tracers section can contain a "params" virtual isotope line of isotopes parameters default values             ====
@@ -939,5 +956,5 @@
     s%zone = PACK(strTail(t(:)%name,'_',lFirst=.TRUE.), MASK = ll)   !--- Tagging zones names  for isotopes category "iname"
     CALL strReduce(s%zone)
-    s%nzon = SIZE(s%zone)                                            !--- Tagging zones number for isotopes category "iname"
+    s%nzone = SIZE(s%zone)                                           !--- Tagging zones number for isotopes category "iname"
 
     !=== Geographic tracers of the isotopes childs of tracer "iname" (same for each phase of "iname")
@@ -945,13 +962,13 @@
     str = PACK(delPhase(t(:)%name), MASK=ll)
     CALL strReduce(str)
-    s%nitr = s%niso + SIZE(str)                                      !--- Number of isotopes + their geographic tracers [ntraciso]
-    ALLOCATE(s%trac(s%nitr))
+    s%ntiso = s%niso + SIZE(str)                                     !--- Number of isotopes + their geographic tracers [ntraciso]
+    ALLOCATE(s%trac(s%ntiso))
     FORALL(it = 1:s%niso) s%trac(it) = s%keys(it)%name
-    FORALL(it = s%niso+1:s%nitr) s%trac(it) = str(it-s%niso)
+    FORALL(it = s%niso+1:s%ntiso) s%trac(it) = str(it-s%niso)
 
     !=== Phases for tracer "iname"
     s%phase = ''
     DO ip = 1, nphases; ph = known_phases(ip:ip); IF(strIdx(t%name,addPhase(iname, ph)) /= 0) s%phase = TRIM(s%phase)//ph; END DO
-    s%npha = LEN_TRIM(s%phase)                                        !--- Equal to "nqo" for water
+    s%nphas = LEN_TRIM(s%phase)                                       !--- Equal to "nqo" for water
 
     !=== Tables giving the index in a table of effectively found items for each dynamical tracer (1<=iq<=nqtot)
@@ -968,10 +985,10 @@
     !=== Table used to get iq (index in dyn array, size nqtot) from the isotope and phase indexes ; the full isotopes list
     !    (including tagging tracers) is sorted this way:  iso1, iso2, ..., iso1_zone1, iso2_zone1, ..., iso1_zoneN, iso2_zoneN
-    s%iTraPha = RESHAPE( [( (strIdx(t(:)%name,  addPhase(s%trac(it),s%phase(ip:ip))),    it=1, s%nitr), ip=1, s%npha)], &
-                         [s%nitr, s%npha] )
-
-    !=== Table used to get ix (index in tagging tracers isotopes list, size nitr) from the zone and isotope indexes
-    s%iZonIso = RESHAPE( [( (strIdx(s%trac(:), TRIM(s%trac(it))//'_'//TRIM(s%zone(iz))), iz=1, s%nzon), it=1, s%niso)], &
-                         [s%nzon, s%niso] )
+    s%iTraPha = RESHAPE( [( (strIdx(t(:)%name,  addPhase(s%trac(it),s%phase(ip:ip))),    it=1, s%ntiso), ip=1, s%nphas)], &
+                         [s%ntiso, s%nphas] )
+
+    !=== Table used to get ix (index in tagging tracers isotopes list, size ntiso) from the zone and isotope indexes
+    s%iZonIso = RESHAPE( [( (strIdx(s%trac(:), TRIM(s%trac(it))//'_'//TRIM(s%zone(iz))), iz=1, s%nzone), it=1, s%niso )], &
+                         [s%nzone, s%niso] )
   END DO
 
@@ -1240,4 +1257,8 @@
   out = s
   IF(s == '') RETURN                                                           !--- Empty string: nothing to do
+
+  !--- Special case: old phases for water, no phases separator
+  IF(ANY([('H2O'//old_phases(ix:ix), ix=1, nphases)] == s)) THEN; out='H2O'; RETURN; END IF
+
   !--- Index of found phase in "known_phases"
   ix = MAXLOC( [(i, i=1,nphases)], MASK=[( INDEX(s, phases_sep//known_phases(i:i))/=0, i=1, nphases)], DIM=1 )
@@ -1252,22 +1273,28 @@
 END FUNCTION delPhase
 !------------------------------------------------------------------------------------------------------------------------------
-CHARACTER(LEN=maxlen) FUNCTION addPhase_1(s,pha) RESULT(out)
-  CHARACTER(LEN=*), INTENT(IN) :: s
-  CHARACTER(LEN=1), INTENT(IN) :: pha
+CHARACTER(LEN=maxlen) FUNCTION addPhase_1(s,pha,ph_sep) RESULT(out)
+  CHARACTER(LEN=*),           INTENT(IN) :: s
+  CHARACTER(LEN=1),           INTENT(IN) :: pha
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: ph_sep
+  CHARACTER(LEN=1) :: psep
   INTEGER :: l, i
   out = s
   IF(s == '') RETURN                                                           !--- Empty string: nothing to do
+  psep = phases_sep; IF(PRESENT(ph_sep)) psep = ph_sep
   i = INDEX(s, '_')                                                            !--- /=0 for <var>_<tag> tracers names
   l = LEN_TRIM(s)
-  IF(i == 0) out =  TRIM(s)//phases_sep//pha                                   !--- <var>       => return <var><sep><pha>
-  IF(i /= 0) out = s(1:i-1)//phases_sep//pha//'_'//s(i+1:l)                    !--- <var>_<tag> => return <var><sep><pha>_<tag>
+  IF(i == 0) out =  TRIM(s)//TRIM(psep)//pha                                   !--- <var>       => return <var><sep><pha>
+  IF(i /= 0) out = s(1:i-1)//TRIM(psep)//pha//'_'//s(i+1:l)                    !--- <var>_<tag> => return <var><sep><pha>_<tag>
 END FUNCTION addPhase_1
 !------------------------------------------------------------------------------------------------------------------------------
-FUNCTION addPhase_m(s,pha) RESULT(out)
-  CHARACTER(LEN=*),      INTENT(IN)  :: s(:)
-  CHARACTER(LEN=1),      INTENT(IN)  :: pha
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: out(:)  
+FUNCTION addPhase_m(s,pha,ph_sep) RESULT(out)
+  CHARACTER(LEN=*),           INTENT(IN) :: s(:)
+  CHARACTER(LEN=1),           INTENT(IN) :: pha
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: ph_sep
+  CHARACTER(LEN=maxlen),     ALLOCATABLE :: out(:)
+  CHARACTER(LEN=1) :: psep
   INTEGER :: k
-  out = [( addPhase_1(s(k), pha), k=1, SIZE(s) )]
+  psep = phases_sep; IF(PRESENT(ph_sep)) psep = ph_sep
+  out = [( addPhase_1(s(k), pha, psep), k=1, SIZE(s) )]
 END FUNCTION addPhase_m
 !------------------------------------------------------------------------------------------------------------------------------
@@ -1282,5 +1309,5 @@
   INTEGER, OPTIONAL, INTENT(IN) :: igen
   INTEGER :: ig, ix
-  ig = 1; IF(PRESENT(igen)) ig = igen
+  ig = 0; IF(PRESENT(igen)) ig = igen
   ix = idxAncestor_1(t, tname, ig)
   out = ''; IF(ix /= 0) out = t(ix)%name
@@ -1294,5 +1321,5 @@
   INTEGER, ALLOCATABLE :: ix(:)
   INTEGER :: ig
-  ig = 1; IF(PRESENT(igen)) ig = igen
+  ig = 0; IF(PRESENT(igen)) ig = igen
   IF(     PRESENT(tname)) ix = idxAncestor_m(t, tname,     ig)
   IF(.NOT.PRESENT(tname)) ix = idxAncestor_m(t, t(:)%name, ig)
@@ -1307,13 +1334,13 @@
 !==============================================================================================================================
 INTEGER FUNCTION idxAncestor_1(t, tname, igen) RESULT(out)
-! Return the name of the generation "igen" ancestor of "tname"
+! Return the name of the generation "igen" (>=0) ancestor of "tname"
   TYPE(trac_type),   INTENT(IN) :: t(:)
   CHARACTER(LEN=*),  INTENT(IN) :: tname
   INTEGER, OPTIONAL, INTENT(IN) :: igen
   INTEGER :: ig
-  ig = 1; IF(PRESENT(igen)) ig = igen
+  ig = 0; IF(PRESENT(igen)) ig = igen
   out = strIdx(t(:)%name, tname)
-  IF(out == 0)          RETURN
-  IF(t(out)%iGeneration <= ig) RETURN
+  IF(out == 0)                 RETURN            !--- Tracer not found
+  IF(t(out)%iGeneration <= ig) RETURN            !--- Tracer has a lower generation number than asked generation 'igen"
   DO WHILE(t(out)%iGeneration > ig); out = strIdx(t(:)%name, t(out)%parent); END DO
 END FUNCTION idxAncestor_1
